/*--------------------------------------------------------------------*/
/*--- Some of rise's data structures and global vars               ---*/
/*---                                              rise_include.h  ---*/
/*--------------------------------------------------------------------*/

/*
   This file is part of RISE, an instruction set randomizer for security,
   built on top of Valgrind, an extensible x86 protected-mode
   emulator for monitoring program execution on x86-Unixes.

   RISE:
   Copyright (C) 2002-2003 Gabriela Barrantes
   	gbarrant@ieee.org

   Valgrind:
   Copyright (C) 2000-2002 Julian Seward 
      jseward@acm.org

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.

   The GNU General Public License is contained in the file COPYING.
*/

//GBS:Note to myself: if no further problems are detected with leaving
//urandom open, delete the commented parts

#include "vg_include.h"

// ====  For rise_scramble.c =============
// 
//GBS: Used in main to make sure that the pool of true randomness was
//"big enough" (in some sense) before using urandom


#define seedSize 256

//---------------***------------------------------------------------
//GBS: File descriptor for /dev/urandom, to be used across the program
Int  RISE_(urandomFD);

//---------------***------------------------------------------------
UChar * * RISE_(level0)[SIZE_LEVEL_0]; //At level 0 we have pointers to pointers to chars

// ==== For rise_magic_sequence_mgmnt.c ====

// GBS: Data structures to authorize magic seq users
// What segments are considered "magic"?
//      - vgskin
//      - "libphthread" (valgrind's reimplementation of it)
//      - vg_main
// A "magic" user is authorized to use VG's magic sequence

typedef
enum { VGSKIN, VGMAIN, VGTHREAD, numAreas}
magicUsers;

/* The following structure is defined in
 * coregrind vg_include.h
 * but I am showing it here so the
 * init magic operations would be clear
 
typedef
struct _memarea {
        UInt start;
        UInt end;
} memarea;

*/

memarea authorized[numAreas];

